Imports System.Runtime.InteropServices

Module ProjectionTypes
    Public Enum PROJSYS As Short
        GM_PRJ_GEO = 0           ' Geographic (lat/lon)
        GM_PRJ_UTM             ' UTM
        GM_PRJ_SPCS               ' US State Plane
        GM_PRJ_ALBERS            ' Albers Conic
        GM_PRJ_LAMCC             ' Lambert Conformal Conic
        GM_PRJ_MERCAT           ' Mercator
        GM_PRJ_PS                 ' Polar Stereographic
        GM_PRJ_POLYC              ' Polyconic
        GM_PRJ_EQUIDC_A          ' Equidistant Conic A
        GM_PRJ_TM                ' Transverse Mercator
        GM_PRJ_STEREO          ' Stereographic
        GM_PRJ_LAMAZ             ' Lambert Azimuthal
        GM_PRJ_AZMEQD             ' Azimuthal Equidistant
        GM_PRJ_GNOMON             ' Gnomonic
        GM_PRJ_ORTHO             ' Orthographic
        GM_PRJ_GVNSP             ' General Vertical Near Side Perspective
        GM_PRJ_SNSOID           ' Sinusoidal
        GM_PRJ_EQRECT          ' Equirectangular
        GM_PRJ_MILLER             ' Miller Cylindrical
        GM_PRJ_VGRINT            ' Van der Grinten 
        GM_PRJ_HOM_A             ' Hotine Oblique Mercator A
        GM_PRJ_ROBIN              ' Robinson
        GM_PRJ_SOM_A             ' Space Oblique Mercator A
        GM_PRJ_ALASKA            ' Alaska Conformal
        GM_PRJ_GOOD              ' Interrupted Goode
        GM_PRJ_MOLL              ' Molleweide
        GM_PRJ_IMOLL             ' Interrupted Molleweide
        GM_PRJ_HAMMER           ' Hammer-Aitoff
        GM_PRJ_WAGIV             ' Wagner IV
        GM_PRJ_WAGVII           ' Wagner VII
        GM_PRJ_OBLEQA            ' Oblated Equal Area
        GM_PRJ_EQUIDC_B          ' Equidistant Conic B
        GM_PRJ_HOM_B           ' Hotine Oblique Mercator B
        GM_PRJ_SOM_B             ' Space Oblique Mercator B
        GM_PRJ_NZMG              ' New Zealand Map Grid
        GM_PRJ_OB_STEREO          ' Oblique Stereographic
        GM_PRJ_GALL              ' Gall Stereographic
        GM_PRJ_ECKERT_IV         ' Eckert IV
        GM_PRJ_AITOFF_WAGNER     ' Aitoff-Wagner
        GM_PRJ_BONNE ' Bonne
        GM_PRJ_CASSINI_SOLDNER   ' Cassini-Soldner
        GM_PRJ_MILOS            ' Miller Oblated Stereographic
        GM_PRJ_TIMES            ' Times
        GM_PRJ_BIPOLAR_CONIC_WEST ' Bipolar Oblique Conic for Western Hemisphere
        GM_PRJ_2PT_EQUIDISTANT  ' Two Point Equidistant
        GM_PRJ_FIXED_SCREEN_POS    ' Fixed Location on the Screen (not a true map projection)
        GM_PRJ_LAMBERT_CYL_EQ_AREA ' Lambert Cylindrical Equal Area
        GM_PRJ_KROVAK              ' Krovak
        GM_PRJ_LAMBERT_MARTA       ' Lambert Marta (WSI Lambert)
        GM_PRJ_LAMBERT_NOAA        ' Lambert NOAA Port (Marta)
        GM_PRJ_MARTA_SATELLITE     ' Marta Satellite projection
        GM_PRJ_WINKEL_I            ' Winkel I
        GM_PRJ_POLYCONIC_INT_MAP   ' International Map of the World Polyconic
        GM_PRJ_WINKEL_TRIPEL       ' Winkel/Tripel
        GM_PRJ_LABORDE             ' Laborde (Madagascar)
        GM_PRJ_TM_SOUTH_ORIENTATED ' Transverse Mercator South Orientated
        GM_PRJ_RSO                 ' RSO (Rectified Skew Orthomorphic)
        GM_PRJ_DOUBLE_STEREOGRAPHIC ' Double Stereographic
        GM_PRJ_INT_SINUSOIDAL      ' Integerized Sinusoidal (MODIS)

        GM_PRJ_NUM_PROJ_SYS      ' Number of full projection systems

        ' Projection aliases
        GM_PRJ_FIRST_ALIAS_PRJ = &H1000
        GM_PRJ_WTM83_91 = GM_PRJ_FIRST_ALIAS_PRJ
        GM_PRJ_MICHIGAN_GEOREF         ' Michigan Georef
        GM_PRJ_SWEDISH_GRID            ' Swedish Grid
        GM_PRJ_BRITISH_GRID            ' British Grid
        GM_PRJ_NZTM_2000               ' New Zealand Transverse Mercator 2000
        GM_PRJ_LAMBERT_I_NORD          ' Lambert I NORD - North of France
        GM_PRJ_LAMBERT_II_CENTRE       ' Lambert II CENTRE - Central France
        GM_PRJ_LAMBERT_III_SUD         ' Lambert III SUD - Southern France
        GM_PRJ_LAMBERT_IV_CORSE        ' Lambert IV CORSE - Corsica
        GM_PRJ_LAMBERT_II_CARTO_ETENDU ' Lambert II CARTO ETENDU - Wide
        GM_PRJ_LAMBERT_93              ' Lambert 93
        GM_PRJ_DUTCH_GRID              ' RijksDriehoeks (RD) - Dutch Grid
        GM_PRJ_STEREO70                ' Stereo70 (Romania)
        GM_PRJ_PLATE_CARREE            ' Plate Carree (Geographic)
        GM_PRJ_GAUSS_KRUEGER           ' Gauss Krueger (6 degree zones)
        GM_PRJ_GAUSS_KRUEGER_GERMANY   ' Gauss Krueger (3 degree zones - Germany)
        GM_PRJ_GAUSS_KRUEGER_SLOVENIA  ' Gauss Krueger (Slovenia)
        GM_PRJ_AUSTRIAN_GRID           ' Austrian Grid
        GM_PRJ_GAUSS_BOAGA             ' Gauss Boaga (Italy)
        GM_PRJ_GREEK_GRID              ' Greek Grid
        GM_PRJ_POLAND_1992_19          ' Polish Coordinate System (1992/19)
        GM_PRJ_GAUSS_KRUEGER_ARGENTINA ' Gauss Krueger (Argentina)
        GM_PRJ_SWISS_GRID              ' Swiss Grid
        GM_PRJ_IRISH_GRID              ' Irish Grid
        GM_PRJ_QUEBEC_MTM              ' Quebec MTM
        GM_PRJ_ISRAEL_GRID_OLD         ' Old Israel Grid
        GM_PRJ_ISRAEL_GRID_NEW         ' New Israel Grid
        GM_PRJ_LAMBERT_I_CARTO         ' Lambert I - North of France
        GM_PRJ_LAMBERT_III_CARTO       ' Lambert III - Southern France
        GM_PRJ_LAMBERT_IV_CARTO        ' Lambert IV - Corsica
        GM_PRJ_HUNGARIAN_EOV           ' Hungarian National Grid (EOV)
        GM_PRJ_RSO_EAST_MALAYSIA       ' East Malaysia BRSO
        GM_PRJ_RSO_WEST_MALAYSIA       ' West Malaysia RSO
        GM_PRJ_CASSINI_MALAYSIA        ' Cassini Malaysia (zoned projection)
        GM_PRJ_KOREAN_GRID             ' Korean Grid
        GM_PRJ_INDIA_GRID              ' India Grid
        GM_PRJ_BELGE_1972              ' Belge 1972 (Belgian Lambert 1972)
        GM_PRJ_MGA                     ' MGA (Map Grid Australia)
        GM_PRJ_NEW_BRUNSWICK_STEREO    ' New Brunswick Stereographic Double
        GM_PRJ_MSTM                    ' MSTM( Mississippi Transverse Mercator)
        GM_PRJ_SYSTEM_1965             ' System 1965 (Uklad 1965) (Poland)
        GM_PRJ_WISCONSIN_COUNTY        ' Wisconsin Coordinate Reference Systems (WISCRS)
        GM_PRJ_PHILIPPINES_GRID        ' Philippines Grid
        GM_PRJ_JAPANESE_GRID           ' Japanese Grid
        GM_PRJ_LAST_ALIAS_PRJ

        GM_PRJ_UNKNOWN = -1
    End Enum

    Public Enum UNIT As Short
        GM_PRJ_UNIT_RADIANS = 0
        GM_PRJ_UNIT_US_FEET
        GM_PRJ_UNIT_METERS
        GM_PRJ_UNIT_ARC_SECONDS
        GM_PRJ_UNIT_ARC_DEGREES
        GM_PRJ_UNIT_INTERNATIONAL_FEET
        GM_PRJ_UNIT_NAUTICAL_MILES
        GM_PRJ_UNIT_YARDS
        GM_PRJ_UNIT_GRADES
        GM_PRJ_UNIT_INDIAN_YARD
        GM_PRJ_UNIT_CLARKE_FEET
        GM_PRJ_UNIT_INCHES

        GM_PRJ_NUM_UNITS
        GM_PRJ_UNIT_UNKNOWN = -1
    End Enum

    Public Enum DATUM As Short
        GM_DATUM_ADINDAN = 0
        GM_DATUM_ARC1950
        GM_DATUM_ARC1960
        GM_DATUM_AUSTRALIAN_GEODETIC_1966
        GM_DATUM_AUSTRALIAN_GEODETIC_1984
        GM_DATUM_CAMP_AREA_ASTRO
        GM_DATUM_CAPE
        GM_DATUM_EUROPEAN_DATUM_1950
        GM_DATUM_EUROPEAN_DATUM_1979
        GM_DATUM_GEODETIC_DATUM_1949
        GM_DATUM_HONG_KONG_1963
        GM_DATUM_HU_TZU_SHAN
        GM_DATUM_INDIAN_1954
        GM_DATUM_NAD27_CONUS
        GM_DATUM_NAD83
        GM_DATUM_OLD_HAWAIIAN_MEAN
        GM_DATUM_OMAN
        GM_DATUM_ORDNANCE_SURVEY_1936
        GM_DATUM_PUERTO_RICO
        GM_DATUM_PULKOVO_1942
        GM_DATUM_PROVISIONAL_S_AMERICAN_1956
        GM_DATUM_TOKYO
        GM_DATUM_WGS_72
        GM_DATUM_WGS_84
        GM_DATUM_NAD27_ALASKA
        GM_DATUM_NAD27_ALEUTIANS_EAST
        GM_DATUM_NAD27_ALEUTIANS_WEST
        GM_DATUM_NAD27_YPG             ' Yuma Proving Ground custom NAD27
        GM_DATUM_SWISS_GRID            ' Swiss Grid CH1903 Datum
        GM_DATUM_EGYPT_1907            ' Old Egyptian 1907
        GM_DATUM_SOUTH_AMERICA_1969    ' South America 1969
        GM_DATUM_RT90                  ' RT90 (Swedish Grid)
        GM_DATUM_GUAM_1963             ' Guam 1963
        GM_DATUM_POTSDAM               ' Potsdam (Germany) datum
        GM_DATUM_MGI_AUSTRIA           ' MGI Austria datum
        GM_DATUM_GDA94                 ' Geocentric Datum of Australia 1994
        GM_DATUM_INDIAN_1975           ' Indian 1975
        GM_DATUM_NZGD_2000             ' New Zealand Geodetic Datum 2000
        GM_DATUM_NAHRWAN               ' Nahrwan 1929 (United Arab Emirates)
        GM_DATUM_S_42_HUNGARY          ' S-42 (Pulkovo 1942) - Hungary
        GM_DATUM_S_42_POLAND           ' S-42 (Pulkovo 1942) - Poland
        GM_DATUM_S_42_CZECH            ' S-42 (Pulkovo 1942) - Czechoslavakia
        GM_DATUM_S_42_LATVIA           ' S-42 (Pulkovo 1942) - Latvia
        GM_DATUM_S_42_KAZAKHSTAN       ' S-42 (Pulkovo 1942) - Kazakhstan
        GM_DATUM_S_42_ALBANIA          ' S-42 (Pulkovo 1942) - Albania
        GM_DATUM_S_42_ROMANIA          ' S-42 (Pulkovo 1942) - Romania
        GM_DATUM_D_48_SLOVENIA         ' D-48 - Slovenia
        GM_DATUM_NAD27_CANADA          ' NAD27 (mean over Canada)
        GM_DATUM_MINNA_CAMEROON        ' Minna - Cameroon
        GM_DATUM_MINNA_NIGERIA         ' Minna - Nigeria
        GM_DATUM_DUTCH                 ' Dutch RD (Netherlands)
        GM_DATUM_ZANDERIJ              ' Zanderij - Suriname
        GM_DATUM_FINLAND_HAYFORD       ' Finland/Hayford
        GM_DATUM_BEIJING_1954          ' Beijing 1954
        GM_DATUM_NGO_1948              ' NGO 1948 (Oslo)
        GM_DATUM_NTF_FRANCE_GREENWICH  ' NTF France (Greenwich Meridian)
        GM_DATUM_CHAD_WG1998           ' Chad WG1998
        GM_DATUM_HJORSEY_1955          ' Hjorsey 1955
        GM_DATUM_BOGOTA_OBSERVATORY    ' Bogota Observatory
        GM_DATUM_SCHWARZECK            ' Schwarzeck - Namibia
        GM_DATUM_NORTH_SAHARA_1959     ' North Sahara 1959
        GM_DATUM_REUNION_ISLAND        ' Reunion Island
        GM_DATUM_IRELAND_1965          ' Ireland 1965
        GM_DATUM_AIN_EL_ABD_BAHRAIN    ' Ain El Abd (Bahrain)
        GM_DATUM_AIN_EL_ABD_SAUDI_ARABIA ' Ain El Abd (Saudi Arabia)
        GM_DATUM_LUZON                 ' Luzon (Phillipines)
        GM_DATUM_CARTHAGE              ' Carthage (Tunisia)
        GM_DATUM_MERCHICH              ' Merchich (Morocco)
        GM_DATUM_NAD27_MEXICO          ' NAD27 (mean over Mexico)
        GM_DATUM_ED50_ENGLAND          ' ED50 - England (EUR_K)
        GM_DATUM_ED50_FINLAND_NORWAY   ' ED50 - Finland and Norway (EUR_C)
        GM_DATUM_ED50_GREECE           ' ED50 - Greece (EUR_B)
        GM_DATUM_ED50_SICILY           ' ED50 - Italy (Sicily) (EUR_J)
        GM_DATUM_ED50_SPAIN_PORTUGAL   ' ED50 - Spain and Portugal (EUR_D)
        GM_DATUM_ROME_1940             ' Rome 1940
        GM_DATUM_KERTAU_1948           ' Kertau 1948
        GM_DATUM_LEIGON                ' Leigon (Ghana)
        GM_DATUM_TIMBALAI_1948         ' Timbalai 1948
        GM_DATUM_ASTRO_B4_SOROL_ATOLL  ' Astro B4 (Sorol Atoll)
        GM_DATUM_ASTRO_BEACON          ' Astro Beacon
        GM_DATUM_ASTRO_DOS_71_4        ' Astro DOS 71/4
        GM_DATUM_ASTRONOMIC_STN_1952   ' Astronomic Station 1952
        GM_DATUM_EASTER_ISLAND_1967    ' Easter Island 1967
        GM_DATUM_HERMANNSKOGEL         ' Hermannskogel
        GM_DATUM_INDIAN_BANGLADESH     ' Indian (Bangladesh)
        GM_DATUM_INDIAN_MEAN_VALUE     ' Indian (Mean)
        GM_DATUM_INDIAN_THAILAND       ' Indian (Thailand)
        GM_DATUM_ISTS_073_ASTRO        ' ISTS 073 Astro
        GM_DATUM_NAD27_BAHAMAS         ' NAD27 (Bahamas)
        GM_DATUM_NAD27_CANAL_ZONE      ' NAD27 (Canal Zone)
        GM_DATUM_NAD27_CARIBBEAN       ' NAD27 (Caribbean)
        GM_DATUM_NAD27_CENTRAL         ' NAD27 (Central America)
        GM_DATUM_NAD27_CUBA            ' NAD27 (Cuba)
        GM_DATUM_NAD27_GREENLAND       ' NAD27 (Greenland)
        GM_DATUM_NAD27_SAN_SALVADOR    ' NAD27 (San Salvador)
        GM_DATUM_OBSERVATORIO_1966     ' Observatorio_1966
        GM_DATUM_PICO_DE_LAS_NIEVES    ' Pico de las Nieves
        GM_DATUM_PORTUGESE_1973        ' Portugese 1973
        GM_DATUM_PROV_S_CHILEAN        ' Provisional South Chilean (1963)
        GM_DATUM_QORNOQ                ' Qornoq
        GM_DATUM_SAO_BRAZ              ' Sao Braz
        GM_DATUM_SOUTHEAST_BASE        ' Southeast Base
        GM_DATUM_SOUTHWEST_BASE        ' Southwest Base
        GM_DATUM_KKJ                   ' KKJ (Finnish Grid)
        GM_DATUM_GGRS87                ' GGRS 1987 (Greek Grid)
        GM_DATUM_POINTE_NOIRE          ' Pointe Noire 1948 (Congo)
        GM_DATUM_RGF_93                ' RGF-93 (France)
        GM_DATUM_CAMPO_INCHAUSPE       ' Campo Inchauspe (Argentina)
        GM_DATUM_ETRS89                ' ETRS89 (coincident with WGS-84 within a meter)
        GM_DATUM_NTF_FRANCE_PARIS      ' NTF France (Pantheon in Paris Meridian)
        GM_DATUM_HARTEBEESTHOEK94      ' Hartebeesthoek94 (South Africa)
        GM_DATUM_INDONESIA_1974        ' Indonesia 1974
        GM_DATUM_BUKIT_RIMPAH          ' Bukit Rimpah
        GM_DATUM_NAD27                 ' NAD27 - auto-selects best NAD27 specialization
        GM_DATUM_LUREF                 ' Luxembourg Reference Datum
        GM_DATUM_QND95                 ' Qatar National Datum 1995
        GM_DATUM_OLD_ISRAELI           ' Old Israeli Datum
        GM_DATUM_NEW_ISRAELI           ' New Israeli Datum
        GM_DATUM_CORREGO_ALEGRE        ' Corrego Alegre (Brazil)
        GM_DATUM_POSGAR94              ' Posgar 94  datum (Argentina)  
        GM_DATUM_HD72                  ' Hungarian datum 1972
        GM_DATUM_ATS77_NOVA_SCOTIA     ' ATS77 (Average Terrestrial System 1977) - Nova Scotia
        GM_DATUM_INDIAN_NEPAL          ' India (Nepal) - Everest 1956 ellipsoid
        GM_DATUM_YACARE                ' Yacare (Uruguay)
        GM_DATUM_TANANARIVE_1925       ' Tananarive Observatory 1925 (Madagascar) (Greenwich PM)
        GM_DATUM_S_JTSK                ' S-JTSK (Czech and Slovak Republics)
        GM_DATUM_GRS80_ELLIPSOID       ' GRS80 Ellipsoid (equivalent to WGS84 included for confused users)
        GM_DATUM_KGD                   ' Korean Geodetic Datum (KGD)
        GM_DATUM_IRELAND_1975          ' Ireland 1965 with 1975 Adjustment
        GM_DATUM_DP1970                ' Dealul Piscului 1970
        GM_DATUM_LISBON_DLX            ' Lisbon (DLx)
        GM_DATUM_SOLOMON_1968          ' Solomon 1968 (GUX 1 Astro)
        GM_DATUM_M_PORALOKO            ' M'Poraloko (Gabon)
        GM_DATUM_GOOGLE_MAPS           ' Google Maps datum (Sphere Radius 6378137 - has special relation to WGS84)
        GM_DATUM_BD72                  ' BD72 (Belgium 1972)
        GM_DATUM_NGO_1948_OSLO         ' NGO 1948 (Oslo Meridian)
        GM_DATUM_TANANARIVE_1925_PARIS ' Tananarive Observatory 1925 (Madagascar) (Paris PM)
        GM_DATUM_ARATU                 ' Aratu (Brazil Oil Exploration)
        GM_DATUM_CAMACUPA              ' Camacupa
        GM_DATUM_JAD69                 ' JAD69 (Jamaica 1969)
        GM_DATUM_JAD2001               ' JAD2001 (Jamaica 2001) [Equivalent to WGS84]
        GM_DATUM_EUROPEAN_DATUM_1987   ' ED87 (European Datum 1987)
        GM_DATUM_S_42_AZ_GEORGIA       ' S-42 (Pulkovo 1942) (Azerbaijan and Georgia)
        GM_DATUM_S_42_ESTONIA          ' S-42 (Pulkovo 1942) (Estonia)
        GM_DATUM_S_42_GERMANY          ' S-42 (Pulkovo 1942) (Germany - Mecklenburg-Vorpommern and Sachsen-Anhalt)
        GM_DATUM_S_42_LITHUANIA        ' S-42 (Pulkovo 1942) (Lithuania)
        GM_DATUM_S_42_RUSSIA           ' S-42 (Pulkovo 1942) (Russia)
        GM_DATUM_IRENET95              ' Ireland IRENET95 datum
        GM_DATUM_PRS92                 ' Philippine Reference System 1992
        GM_DATUM_MALONGO_1987          ' Malongo 1987
        GM_DATUM_SWEREF99              ' SWEREF99
        GM_DATUM_KOREAN_1985           ' Korean 1985
        GM_DATUM_KOREAN_1995           ' Korean 1995
        GM_DATUM_HERAT_NORTH           ' Herat North
        GM_DATUM_DEIR_EZ_ZOR           ' Deir ez Zor (Syria)
        GM_DATUM_EGYPT_GULF_OF_SUEZ    ' Egypt Gulf of Suez S-650 TL
        GM_DATUM_JORDAN                ' Jordan
        GM_DATUM_FD_1958               ' FD 1958 (Iraq)
        GM_DATUM_OCOTEPEQUE            ' Ocotepeque (Costa Rica)
        GM_DATUM_ISN93                 ' ISN93 (Island Network 1993) - Iceland
        GM_DATUM_REYKJAVIK_1900        ' Reykjavik 1900
        GM_DATUM_ESTONIA_1997          ' Estonia 1997
        GM_DATUM_TRINIDAD_1903         ' Trinidad 1903
        GM_DATUM_LKS92                 ' LKS92 (Latvia)
        GM_DATUM_MODIS_SPHEROID        ' Spheroid Used by MODIS Imagery
        GM_DATUM_ETRF_2000             ' ETRF2000 - RDN
        GM_DATUM_ROME_1940_ROME        ' Rome 1940 (Monte Mario) - Rome Meridian

        ' Child datums
        GM_DATUM_CHILD_FIRST = &H1000
        GM_DATUM_NAD83_ALABAMA         ' Alabama HPGN
        GM_DATUM_NAD83_ARIZONA         ' Arizona HPGN
        GM_DATUM_NAD83_ARKANSAS        ' Arkansas HPGN
        GM_DATUM_NAD83_CALIFORNIA_NORTH ' California - North HPGN
        GM_DATUM_NAD83_CALIFORNIA_SOUTH ' California - South HPGN
        GM_DATUM_NAD83_COLORADO        ' Colorado HPGN
        GM_DATUM_NAD83_FLORIDA         ' Florida HPGN
        GM_DATUM_NAD83_GEORGIA         ' Georgia HPGN
        GM_DATUM_NAD83_HAWAII          ' Hawaii HPGN
        GM_DATUM_NAD83_ILLINOIS        ' Illinois HPGN
        GM_DATUM_NAD83_INDIANA         ' Indiana HPGN
        GM_DATUM_NAD83_IOWA            ' Iowa HPGN
        GM_DATUM_NAD83_KANSAS          ' Kansas HPGN
        GM_DATUM_NAD83_KENTUCKY        ' Kentucky HPGN
        GM_DATUM_NAD83_LOUISIANA       ' Louisiana HPGN
        GM_DATUM_NAD83_MAINE           ' Maine HPGN
        GM_DATUM_NAD83_MARYLAND        ' Maryland-Delaware HPGN
        GM_DATUM_NAD83_MICHIGAN        ' Michigan HPGN
        GM_DATUM_NAD83_MINNESOTA       ' Minnesota HPGN
        GM_DATUM_NAD83_MISSISSIPPI     ' Mississippi HPGN
        GM_DATUM_NAD83_MISSOURI        ' Missouri HPGN
        GM_DATUM_NAD83_MONTANA_EAST    ' Montana East HPGN
        GM_DATUM_NAD83_MONTANA_WEST    ' Montana West/Idaho HPGN
        GM_DATUM_NAD83_NEBRASKA        ' Nebraska HPGN
        GM_DATUM_NAD83_NEVADA          ' Nevada HPGN
        GM_DATUM_NAD83_NEW_ENGLAND     ' New England HPGN
        GM_DATUM_NAD83_NEW_JERSEY      ' New Jersey HPGN
        GM_DATUM_NAD83_NEW_MEXICO      ' New Mexico HPGN
        GM_DATUM_NAD83_NEW_YORK        ' New York HPGN
        GM_DATUM_NAD83_NORTH_DAKOTA    ' North Dakota HPGN
        GM_DATUM_NAD83_OHIO            ' Ohio HPGN
        GM_DATUM_NAD83_OKLAHOMA        ' Oklahoma HPGN
        GM_DATUM_NAD83_PENNSYLVANIA    ' Pennsylvania HPGN
        GM_DATUM_NAD83_PUERTO_RICO     ' Puerto Rico/Virgin Islands HPGN
        GM_DATUM_NAD83_SOUTH_DAKOTA    ' South Dakota HPGN
        GM_DATUM_NAD83_TENNESSEE       ' Tennessee HPGN
        GM_DATUM_NAD83_TEXAS_EAST      ' Texas East HPGN
        GM_DATUM_NAD83_TEXAS_WEST      ' Texas West HPGN
        GM_DATUM_NAD83_UTAH            ' Utah HPGN
        GM_DATUM_NAD83_VIRGINIA        ' Virginia HPGN
        GM_DATUM_NAD83_WASHINGTON      ' Washington-Oregon HPGN
        GM_DATUM_NAD83_WEST_VIRGINIA   ' West Virginia HPGN
        GM_DATUM_NAD83_WISCONSIN       ' Wisconsin HPGN
        GM_DATUM_NAD83_WYOMING         ' Wyoming HPGN
        GM_DATUM_MN_ANOKA              ' Minnesota County Datum
        GM_DATUM_MN_BECKER             ' Minnesota County Datum
        GM_DATUM_MN_BELTRAMI_NORTH     ' Minnesota County Datum
        GM_DATUM_MN_BELTRAMI_SOUTH     ' Minnesota County Datum
        GM_DATUM_MN_BENTON             ' Minnesota County Datum
        GM_DATUM_MN_BIG_STONE          ' Minnesota County Datum
        GM_DATUM_MN_BLUE_EARTH         ' Minnesota County Datum
        GM_DATUM_MN_BROWN              ' Minnesota County Datum
        GM_DATUM_MN_CARLTON            ' Minnesota County Datum
        GM_DATUM_MN_CARVER             ' Minnesota County Datum
        GM_DATUM_MN_CASS_NORTH         ' Minnesota County Datum
        GM_DATUM_MN_CASS_SOUTH         ' Minnesota County Datum
        GM_DATUM_MN_CHIPPEWA           ' Minnesota County Datum
        GM_DATUM_MN_CHISAGO            ' Minnesota County Datum
        GM_DATUM_MN_COOK_NORTH         ' Minnesota County Datum
        GM_DATUM_MN_COOK_SOUTH         ' Minnesota County Datum
        GM_DATUM_MN_COTTONWOOD         ' Minnesota County Datum
        GM_DATUM_MN_CROW_WING          ' Minnesota County Datum
        GM_DATUM_MN_DAKOTA             ' Minnesota County Datum
        GM_DATUM_MN_DODGE              ' Minnesota County Datum
        GM_DATUM_MN_DOUGLAS            ' Minnesota County Datum
        GM_DATUM_MN_FARIBAULT          ' Minnesota County Datum
        GM_DATUM_MN_FILLMORE           ' Minnesota County Datum
        GM_DATUM_MN_FREEBORN           ' Minnesota County Datum
        GM_DATUM_MN_GOODHUE            ' Minnesota County Datum
        GM_DATUM_MN_GRANT              ' Minnesota County Datum
        GM_DATUM_MN_HENNEPIN           ' Minnesota County Datum
        GM_DATUM_MN_HOUSTON            ' Minnesota County Datum
        GM_DATUM_MN_ISANTI             ' Minnesota County Datum
        GM_DATUM_MN_ITASCA_NORTH       ' Minnesota County Datum
        GM_DATUM_MN_ITASCA_SOUTH       ' Minnesota County Datum
        GM_DATUM_MN_JACKSON            ' Minnesota County Datum
        GM_DATUM_MN_KANABEC            ' Minnesota County Datum
        GM_DATUM_MN_KANDIYOHI          ' Minnesota County Datum
        GM_DATUM_MN_KITTSON            ' Minnesota County Datum
        GM_DATUM_MN_KOOCHICHING        ' Minnesota County Datum
        GM_DATUM_MN_LAC_QUI_PARLE      ' Minnesota County Datum
        GM_DATUM_MN_LAKE_OF_THE_WOODS_NORTH ' Minnesota County Datum
        GM_DATUM_MN_LAKE_OF_THE_WOODS_SOUTH ' Minnesota County Datum
        GM_DATUM_MN_LE_SUEUR           ' Minnesota County Datum
        GM_DATUM_MN_LINCOLN            ' Minnesota County Datum
        GM_DATUM_MN_LYON               ' Minnesota County Datum
        GM_DATUM_MN_MCLEOD             ' Minnesota County Datum
        GM_DATUM_MN_MAHNOMEN           ' Minnesota County Datum
        GM_DATUM_MN_MARSHALL           ' Minnesota County Datum
        GM_DATUM_MN_MARTIN             ' Minnesota County Datum
        GM_DATUM_MN_MEEKER             ' Minnesota County Datum
        GM_DATUM_MN_MORRISON           ' Minnesota County Datum
        GM_DATUM_MN_MOWER              ' Minnesota County Datum
        GM_DATUM_MN_MURRAY             ' Minnesota County Datum
        GM_DATUM_MN_NICOLLET           ' Minnesota County Datum
        GM_DATUM_MN_NOBLES             ' Minnesota County Datum
        GM_DATUM_MN_NORMAN             ' Minnesota County Datum
        GM_DATUM_MN_OLMSTED            ' Minnesota County Datum
        GM_DATUM_MN_OTTERTAIL          ' Minnesota County Datum
        GM_DATUM_MN_PENNINGTON         ' Minnesota County Datum
        GM_DATUM_MN_PINE               ' Minnesota County Datum
        GM_DATUM_MN_PIPESTONE          ' Minnesota County Datum
        GM_DATUM_MN_POLK               ' Minnesota County Datum
        GM_DATUM_MN_POPE               ' Minnesota County Datum
        GM_DATUM_MN_RAMSEY             ' Minnesota County Datum
        GM_DATUM_MN_RED_LAKE           ' Minnesota County Datum
        GM_DATUM_MN_REDWOOD            ' Minnesota County Datum
        GM_DATUM_MN_RENVILLE           ' Minnesota County Datum
        GM_DATUM_MN_RICE               ' Minnesota County Datum
        GM_DATUM_MN_ROCK               ' Minnesota County Datum
        GM_DATUM_MN_ROSEAU             ' Minnesota County Datum
        GM_DATUM_MN_ST_LOUIS_NORTH     ' Minnesota County Datum
        GM_DATUM_MN_ST_LOUIS_CENTRAL   ' Minnesota County Datum
        GM_DATUM_MN_ST_LOUIS_SOUTH     ' Minnesota County Datum
        GM_DATUM_MN_SCOTT              ' Minnesota County Datum
        GM_DATUM_MN_SHERBURNE          ' Minnesota County Datum
        GM_DATUM_MN_SIBLEY             ' Minnesota County Datum
        GM_DATUM_MN_STEARNS            ' Minnesota County Datum
        GM_DATUM_MN_STEELE             ' Minnesota County Datum
        GM_DATUM_MN_STEVENS            ' Minnesota County Datum
        GM_DATUM_MN_SWIFT              ' Minnesota County Datum
        GM_DATUM_MN_TODD               ' Minnesota County Datum
        GM_DATUM_MN_TRAVERSE           ' Minnesota County Datum
        GM_DATUM_MN_WABASHA            ' Minnesota County Datum
        GM_DATUM_MN_WADENA             ' Minnesota County Datum
        GM_DATUM_MN_WASECA             ' Minnesota County Datum
        GM_DATUM_MN_WATONWAN           ' Minnesota County Datum
        GM_DATUM_MN_WINONA             ' Minnesota County Datum
        GM_DATUM_MN_WRIGHT             ' Minnesota County Datum
        GM_DATUM_MN_YELLOW_MEDICINE    ' Minnesota County Datum
        GM_DATUM_WI_SHEBOYGAN          ' Wisconsin County Datum
        GM_DATUM_ED50_ITALY            ' ED50 - Italy
        GM_DATUM_NAD83_SOUTH_CAROLINA  ' South Carolina HPGN

        ' Interplanetary datums
        GM_DATUM_IP_FIRST = &H4000
        GM_DATUM_IP_MERCURY = GM_DATUM_IP_FIRST
        GM_DATUM_IP_VENUS
        GM_DATUM_IP_VENUS_1985
        GM_DATUM_IP_MOON
        GM_DATUM_IP_MARS_2001
        GM_DATUM_IP_MARS_1990
        GM_DATUM_IP_JUPITER
        GM_DATUM_IP_IO
        GM_DATUM_IP_EUROPA
        GM_DATUM_IP_GANYMEDE
        GM_DATUM_IP_CALLISTO
        GM_DATUM_IP_SATURN
        GM_DATUM_IP_TITAN
        GM_DATUM_IP_URANUS
        GM_DATUM_IP_NEPTUNE
        GM_DATUM_IP_PLUTO

        ' Special datum values
        GM_DATUM_UNKNOWN = -1
        GM_DATUM_NONE = -2
        GM_DATUM_DEFAULT = -3
        GM_DATUM_CUSTOM_FIRST = &H2000
    End Enum

    Public Enum PROJATTR As Short
        FIRST_STANDARD_PARALLEL = 0
        SECOND_STANDARD_PARALLEL
        CENTRAL_LATITUDE
        CENTRAL_LONGITUDE
        FALSE_EASTING
        FALSE_NORTHING
        SPHERE_RADIUS
        ORIGIN_LATITUDE
        SEMI_MAJOR_AXIS
        SEMI_MINOR_AXIS
        CENTRAL_MERIDIAN
        STANDARD_PARALLEL
        TRUE_SCALE_LATITUDE
        AZIMUTH_ANGLE
        AZIMUTH_POINT
        LATITUDE1
        LATITUDE2
        LONGITUDE1
        LONGITUDE2
        PROJ_CENTER_SCALE_FACTOR
        LONGITUDE_POLE
        CENTRAL_MERIDIAN_SCALE_FACTOR
        PERSPECTIVE_POINT_HEIGHT
        INCLINATION_ANGLE
        ASCENTION_LONGITUDE
        SAT_REV_PERIOD
        END_OF_PATH_FLAG
        LANDSAT_SAT_NUM
        OEA_SHAPE_PARM_M
        OEA_SHAPE_PARM_N
        OEA_OVAL_ROTATION_ANGLE
        ZONE
        GM_PRJ_ATTR_STATE_PLANE_SCALE_FACTOR   ' extra scale factor for State Plane projections

        ' Attributes for GM_PRJ_FIXED_SCREEN_POS projection
        GM_PRJ_ATTR_HORZ_OFFSET        ' horizontal offset value in inches percent or longitude
        GM_PRJ_ATTR_HORZ_OFFSET_TYPE   ' horizontal offset type (0 - left 1 - right 2 - centered)
        GM_PRJ_ATTR_HORZ_OFFSET_VTYPE  ' horizontal offset value type (0 - inches 1 - percent 2 - degrees longitude)
        GM_PRJ_ATTR_VERT_OFFSET        ' vertical offset value in inches percent or latitude
        GM_PRJ_ATTR_VERT_OFFSET_TYPE   ' vertical offset type (0 - top 1 - bottom 2 - centered)
        GM_PRJ_ATTR_VERT_OFFSET_VTYPE  ' vertical offset value type (0 - inches 1 - percent 2 - degrees latitude)
        GM_PRJ_ATTR_SIZE_VALUE         ' size value (percent)
        GM_PRJ_ATTR_SIZE_VALUE_TYPE    ' size value type (0 - fixed pixel size 1 - percent width 2 - percent height)
        GM_PRJ_ATTR_ALWAYS_ON_TOP      ' make this fixed screen file show on top of everything else

        ' Additional attributes
        GM_PRJ_ATTR_STATE_PLANE_EXTRA_FALSE_EASTING    ' extra false easting (in meters) for State Plane projections to apply AFTER the extra scale factor
        GM_PRJ_ATTR_STATE_PLANE_EXTRA_FALSE_NORTHING   ' extra false northing (in meters) for State Plane projections to apply AFTER the extra scale factor
        GM_PRJ_ATTR_STATE_PLANE_SCALE_CENTER_EASTING   ' easting of location at which to apply extra scale factor for State Plane projections
        GM_PRJ_ATTR_STATE_PLANE_SCALE_CENTER_NORTHING  ' northing of location at which to apply extra scale factor for State Plane projections

        NUM_PROJ_ATTR_TYPES
        GM_MAX_ATTR_PER_PROJ = 16  ' maximum attributes a single projection might have
    End Enum

End Module
